function Y = parfor_LGG3(X)
KeplerDir = cd;
cd ..
cd ..
PhSpGeoDir = cd;
cd(KeplerDir)
ext = X{1,1}; stepG = X{1,2}; stepG3 = X{1,3}; RotS = X{1,4}; RotD = X{1,5};
Output_Step = X{1,6}; options = X{1,7};
S_vec_o = X{1,8}; D_vec_o = X{1,9}; handles = X(1,10);
begin = X{1,11}; mainbar = X{1,12};

handles = handles{1,1};
sm_ax_o = 1;
f_o =   0;
omega_o = str2num(get(handles.edit_LGG3_perprime,'String'));
G_init = str2num(get(handles.edit_Init_Gprime,'String'));
row_tot = str2num(get(handles.edit_Step_Gprime,'String')) + 1;
G3_init = str2num(get(handles.edit_Init_G3prime,'String'));
col_tot = str2num(get(handles.edit_Step_G3prime,'String')) + 1;
E_tot = str2num(get(handles.edit_EnergyLGG3,'String'));
lambda_tot = 1/sqrt(-2*E_tot);

int_tot = min(row_tot, col_tot);
ext_tot = max(row_tot, col_tot);

epsilon1 = str2num(get(handles.edit_epsilon1,'String'));
epsilon2 = str2num(get(handles.edit_epsilon2,'String'));
epsilon3 = str2num(get(handles.edit_epsilon3,'String'));
epsilon4 = str2num(get(handles.edit_epsilon4,'String'));
epsilon5 = str2num(get(handles.edit_epsilon5,'String'));

contents = get(handles.popupmenuHp1,'String');
item = get(handles.popupmenuHp1,'Value');
Hp1 = char(contents(item));
degrees = get(handles.popupmenuHp1,'UserData');
deg1 = degrees(item);

contents = get(handles.popupmenuHp2,'String');
item = get(handles.popupmenuHp2,'Value');
Hp2 = char(contents(item));
degrees = get(handles.popupmenuHp2,'UserData');
deg2 = degrees(item);

contents = get(handles.popupmenuHp3,'String');
item = get(handles.popupmenuHp3,'Value');
Hp3 = char(contents(item));
degrees = get(handles.popupmenuHp3,'UserData');
deg3 = degrees(item);

contents = get(handles.popupmenuHp4,'String');
item = get(handles.popupmenuHp4,'Value');
Hp4 = char(contents(item));
degrees = get(handles.popupmenuHp4,'UserData');
deg4 = degrees(item);

contents = get(handles.popupmenuHp5,'String');
item = get(handles.popupmenuHp5,'Value');
Hp5 = char(contents(item));
degrees = get(handles.popupmenuHp5,'UserData');
deg5 = degrees(item);

contents = get(handles.popupmenuODE,'String');
item = get(handles.popupmenuODE,'Value');
ODE = char(contents(item));

tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));

extstr = num2str(ext);
if row_tot <= col_tot   
    G3_step = G3_init + stepG3*(ext-1);
else
    G_step = G_init + stepG*(ext-1);    
end

ccount = 0;

for int = 1:int_tot
    if row_tot <= col_tot
        G_step = G_init + stepG*(int-1);        
    else
        G3_step = G3_init + stepG3*(int-1);
    end

    if abs(G3_step) > G_step
        freq_1(int) = NaN;
        freq_min_1(int) = NaN;
        freq_max_1(int) = NaN;
        freq_2(int) = NaN;
        freq_min_2(int) = NaN;
        freq_max_2(int) = NaN;        
        freq_3(int) = NaN;
        freq_min_3(int) = NaN;
        freq_max_3(int) = NaN;               
    else
        G_step_vec_prime = [0  -sqrt(G_step^2-G3_step^2)  G3_step];
        R_step_vec_prime = sqrt(sm_ax_o-G_step^2)*[cos(pi/180*omega_o)  sin(pi/180*omega_o)*G3_step/G_step  ...
            sin(pi/180*omega_o)*sqrt(1- G3_step^2/G_step^2)];
        S_step_vec_prime = 1/2*(G_step_vec_prime + R_step_vec_prime);
        D_step_vec_prime = 1/2*(G_step_vec_prime - R_step_vec_prime);
        S_vec = S_step_vec_prime*RotS';
        D_vec = D_step_vec_prime*RotD';
        [q_vec_o, p_vec_o] = SD2Cartesian(S_vec, D_vec);
        
%------------------------------------------------------------------------
        lambd = lambda_tot + 1;
        clear global lambda
        kk = 0;
        while abs(lambd - lambda_tot) > 1e-02
            if kk > 50
                break
            end
            lambd = 1/sqrt(-2*(1/2*p_vec_o*p_vec_o' - 1/sqrt(q_vec_o*q_vec_o')...
                + Hp(q_vec_o, p_vec_o, epsilon1, epsilon2, epsilon3, epsilon4, epsilon5, Hp1, Hp2, Hp3, Hp4, Hp5)));
            
            if ~isreal(lambd)
                break
            end
            
            q_vec_o = lambda_tot^2*q_vec_o/lambd^2;
            p_vec_o = p_vec_o*lambd/lambda_tot;
            kk = kk + 1;
        end
        
        if (~isreal(lambd) | isnan(lambd))
            [q_vec_o, p_vec_o] = SD2Cartesian(S_vec, D_vec);
        end
        
        f = @(z)1/sqrt(-2*(1/2*z^2*p_vec_o*p_vec_o' - 1/sqrt(q_vec_o*q_vec_o')*z^2 ...
                + Hp(q_vec_o/z^2, p_vec_o*z, epsilon1, epsilon2, epsilon3, epsilon4, epsilon5, Hp1, Hp2, Hp3, Hp4, Hp5))) - lambda_tot;
        opts = optimset('Display','off');
        
        try
            a = fzero(f,1,opts);
        catch
            disp('With the selected value of Total Energy it is impossible to find')
            disp('the initial conditions for a correct value of G and G3.')
            disp('Some error occurred: the corresponding frequency and FMI values will be left blank.')
            disp('    ')            
            freq_1(int) = NaN;
            freq_min_1(int) = NaN;
            freq_max_1(int) = NaN;
            freq_2(int) = NaN;
            freq_min_2(int) = NaN;
            freq_max_2(int) = NaN;        
            freq_3(int) = NaN;
            freq_min_3(int) = NaN;
            freq_max_3(int) = NaN;
            cd(KeplerDir)            
            continue
        end

        if isnan(a)
            disp('With the selected value of Total Energy it is impossible to find')
            disp('the initial conditions for a correct value of G and G3.')
            disp('Some error occurred: the corresponding frequency and FMI values will be left blank.')
            disp('    ')            
            freq_1(int) = NaN;
            freq_min_1(int) = NaN;
            freq_max_1(int) = NaN;
            freq_2(int) = NaN;
            freq_min_2(int) = NaN;
            freq_max_2(int) = NaN;        
            freq_3(int) = NaN;
            freq_min_3(int) = NaN;
            freq_max_3(int) = NaN;
            cd(KeplerDir)            
            continue
        end                  
        q_vec_o = q_vec_o/a^2;
        p_vec_o = p_vec_o*a;
        global lambda
        lambda = lambda_tot;
%--------------------------------------------------------------------------
        x_vec_o = 1/(lambda^2)*q_vec_o;
        y_vec_o = lambda*p_vec_o;     
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        if get(handles.radiobutton_Pert_LGG3,'Value') == 1  
            [Uo, Vo] = xy2uv(x_vec_o, y_vec_o);
        elseif get(handles.radiobutton_NonPert_LGG3,'Value') == 1   
            [z_vec_o,  w_vec_o] = xy2zw(x_vec_o,  y_vec_o);
            Uo = z_vec_o';
            Vo = w_vec_o';
        end       
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     TOM
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        block = str2num(get(handles.edit_block,'String'));
        OutStep = str2num(get(handles.edit_StepSize,'String'));
        if strcmp(ODE, 'Tom') == 1
            if block
                n_cycle = floor(tau_total/block);
                k = 1; w = []; tau_ = [];
                for k = 1:n_cycle               
                    sol = tomgm('DiffEquation', [(k-1)*block  k*block], [Uo; Vo], options);               
                    W = sol.y';
                    tau_c = sol.x;    
                    w = [w; W(1:length(W)-1, :)];
                    tau_ = [tau_; tau_c(1:length(W)-1)];
                    W_o = W(length(W), :);
                    Uo = W_o(1:4)';
                    Vo = W_o(5:8)';

                    if get(handles.radiobutton_Pert,'Value') == 1
                        [xo yo] = uv2xy(Uo, Vo);       
                        [Uo Vo] = xy2uv(xo, yo);        
                        [xo yo] = uv2xy(Uo, Vo);
                    elseif get(handles.radiobutton_NonPert,'Value') == 1
                        [xo yo] = zw2xy(Uo, Vo);
                        [Uo Vo] = xy2zw(xo, yo);           
                        [xo yo] = zw2xy(Uo, Vo);
                    end

%-------------------------------------------------------------------------------                
%{
                Ktot = 1.001;
                while abs(Ktot-1) > 5*eps
                    Ktot = 1/2*sqrt(xo*xo')*(yo*yo'+1) + sqrt(xo*xo')*...
                    Kp(xo,yo, lambda, epsilon1, epsilon2, epsilon3, epsilon4,...
                        deg1, deg2, deg3, deg4, Hp1, Hp2, Hp3, Hp4);
                    xo = xo/Ktot;
                end           
%}
                f = @(z)1/2*sqrt(z^2*xo*xo')*(yo*yo'+1) + sqrt(z^2*xo*xo')*...
                    Kp(z*xo,yo, lambda, epsilon1, epsilon2, epsilon3, epsilon4, epsilon5,...
                        deg1, deg2, deg3, deg4, deg5, Hp1, Hp2, Hp3, Hp4, Hp5) - 1;
                a = fzero(f,1);
                xo =a*xo;
%---------------------------------------------------------------------------------------------            

                    if get(handles.radiobutton_Pert,'Value') == 1
                        [Uo Vo] = xy2uv(xo, yo);
                    elseif get(handles.radiobutton_NonPert,'Value') == 1
                        [Uo Vo] = xy2zw(xo, yo);
                        Uo = Uo'; Vo = Vo';
                    end     
                end
                if (n_cycle*block ~= tau_total)
                    sol = tomgm('DiffEquation', [n_cycle*block  tau_total], [Uo; Vo], options);
                    W = sol.y';
                    tau_c = sol.x;
                    W = [w; W];
                    tau_c = [tau_; tau_c];       
                else
                    W = w;
                    tau_c = tau_;
                end
            else            
                sol = tomgm('DiffEquation', [0 tau_total], [Uo; Vo], options);
                W = sol.y';
                tau_c = sol.x;
            end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     Runge-Kutta
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%            
        elseif (strcmp(ODE, 'RungeKutta4') == 1) | (strcmp(ODE, 'RungeKutta5') == 1)
            OutStep = str2num(get(handles.edit_FixedStepSize,'String'));
            tau_c = (0 : OutStep : tau_total)';           
            W = eval([ODE, '(@DiffEquation, tau_c, [Uo; Vo])']);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     IRKGauss
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%            
        elseif (strcmp(ODE, 'IRKGauss') == 1)
            OutStep = str2num(get(handles.edit_FixedStepSize,'String'));
            opt.method = str2num(get(handles.edit_IRKMeth,'String'));
            if block
                opt.nstep = block/OutStep;
                n_cycle = floor(tau_total/block);
                k = 1; w = []; tau_ = [];
                for k = 1:n_cycle        
                    [tau_c,W] = eval([ODE, '(@DiffEquation, [(k-1)*block , k*block], [Uo; Vo], opt)']);        
                    w = [w; W(1:length(W)-1, :)];
                    tau_ = [tau_; tau_c(1:length(W)-1)];
                    W_o = W(length(W), :);
                    Uo = W_o(1:4)';
                    Vo = W_o(5:8)';

                    if get(handles.radiobutton_Pert,'Value') == 1
                        [xo yo] = uv2xy(Uo, Vo);       
                        [Uo Vo] = xy2uv(xo, yo);        
                        [xo yo] = uv2xy(Uo, Vo);
                    elseif get(handles.radiobutton_NonPert,'Value') == 1
                        [xo yo] = zw2xy(Uo, Vo);
                        [Uo Vo] = xy2zw(xo, yo);           
                        [xo yo] = zw2xy(Uo, Vo);
                    end

%--------------------------------------------------------------------------------                
%{
                Ktot = 1.001;
                while abs(Ktot-1) > 5*eps
                    Ktot = 1/2*sqrt(xo*xo')*(yo*yo'+1) + sqrt(xo*xo')*...
                    Kp(xo,yo, lambda, epsilon1, epsilon2, epsilon3, epsilon4,...
                        deg1, deg2, deg3, deg4, Hp1, Hp2, Hp3, Hp4);
                    xo = xo/Ktot;
                end           
%}
                f = @(z)1/2*sqrt(z^2*xo*xo')*(yo*yo'+1) + sqrt(z^2*xo*xo')*...
                    Kp(z*xo,yo, lambda, epsilon1, epsilon2, epsilon3, epsilon4, epsilon5,...
                        deg1, deg2, deg3, deg4, deg5, Hp1, Hp2, Hp3, Hp4, Hp5) - 1;
                a = fzero(f,1);
                xo =a*xo;
%---------------------------------------------------------------------------------------------           

                    if get(handles.radiobutton_Pert,'Value') == 1
                        [Uo Vo] = xy2uv(xo, yo);
                    elseif get(handles.radiobutton_NonPert,'Value') == 1
                        [Uo Vo] = xy2zw(xo, yo);
                        Uo = Uo'; Vo = Vo';
                    end     
                end
                if (n_cycle*block ~= tau_total)
                    opt.nstep = (tau_total - n_cycle*block)/OutStep;
                    [tau_c,W] = eval([ODE, '(@DiffEquation, [n_cycle*block , tau_total], [Uo; Vo], opt)']);
                    W = [w; W];
                    tau_c = [tau_; tau_c];
                else
                    W = w;
                    tau_c = tau_;
                end
            else            
                OutStep = str2num(get(handles.edit_FixedStepSize,'String'));
                opt.method = str2num(get(handles.edit_IRKMeth,'String'));
                opt.nstep = tau_total/OutStep;          
                [tau_c,W] = eval([ODE, '(@DiffEquation, [0, tau_total], [Uo; Vo], opt)']);
            end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     Other ODE solver
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%            
        else
            OutStepst = get(handles.edit_OutputStep,'String');
            if isempty(OutStepst)
                set(handles.edit_OutputStep,'String','0.01');
                OutStepst = '0.01';
                Output_Step = [':',OutStepst,':'];
            else
                Output_Step = [':',OutStepst,':'];
            end
            OutStep = str2num(OutStepst);
            if block
                n_cycle = floor(tau_total/block);
                k = 1; w = []; tau_ = [];
                for k = 1:n_cycle            
                    [tau_c,W] = eval([ODE, '(''DiffEquation'', [(k-1)*block ',Output_Step,' k*block], [Uo; Vo], options)']);             
                    w = [w; W(1:length(W)-1, :)];
                    tau_ = [tau_; tau_c(1:length(W)-1)];
                    W_o = W(length(W), :);
                    Uo = W_o(1:4)';
                    Vo = W_o(5:8)';

                    if get(handles.radiobutton_Pert,'Value') == 1
                        [xo yo] = uv2xy(Uo, Vo);       
                        [Uo Vo] = xy2uv(xo, yo);        
                        [xo yo] = uv2xy(Uo, Vo);
                    elseif get(handles.radiobutton_NonPert,'Value') == 1
                        [xo yo] = zw2xy(Uo, Vo);
                        [Uo Vo] = xy2zw(xo, yo);           
                        [xo yo] = zw2xy(Uo, Vo);
                    end

%--------------------------------------------------------------------------------------                
%{
                Ktot = 1.001;
                while abs(Ktot-1) > 5*eps
                    Ktot = 1/2*sqrt(xo*xo')*(yo*yo'+1) + sqrt(xo*xo')*...
                    Kp(xo,yo, lambda, epsilon1, epsilon2, epsilon3, epsilon4,...
                        deg1, deg2, deg3, deg4, Hp1, Hp2, Hp3, Hp4);
                    xo = xo/Ktot;
                end           
%}
                f = @(z)1/2*sqrt(z^2*xo*xo')*(yo*yo'+1) + sqrt(z^2*xo*xo')*...
                    Kp(z*xo,yo, lambda, epsilon1, epsilon2, epsilon3, epsilon4, epsilon5,...
                        deg1, deg2, deg3, deg4, deg5, Hp1, Hp2, Hp3, Hp4, Hp5) - 1;
                a = fzero(f,1);
                xo =a*xo;
%---------------------------------------------------------------------------------------------           

                    if get(handles.radiobutton_Pert,'Value') == 1
                        [Uo Vo] = xy2uv(xo, yo);
                    elseif get(handles.radiobutton_NonPert,'Value') == 1
                        [Uo Vo] = xy2zw(xo, yo);
                        Uo = Uo'; Vo = Vo';
                    end        

                end
                if (n_cycle*block ~= tau_total)
                    [tau_c,W] = eval([ODE, '(''DiffEquation'', [n_cycle*block ',Output_Step,' tau_total], [Uo; Vo], options)']);
                    W = [w; W];
                    tau_c = [tau_; tau_c];
                else
                    W = w;
                    tau_c = tau_;
                end
            else            
                [tau_c,W] = eval([ODE, '(''DiffEquation'', [0 ',Output_Step,' tau_total], [Uo; Vo], options)']);
            end
        end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        if get(handles.radiobutton_Pert_LGG3,'Value') == 1
            Calculate_Trajectories
        elseif get(handles.radiobutton_NonPert_LGG3,'Value') == 1
            Calculate_TrajectoriesNonPert
        end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        norma_q = sqrt((sum((q_vec.^2)'))');
        sm_ax = norma_q./(2-((sum((p_vec.^2)'))').*norma_q);
        if all(sm_ax > zeros(size(sm_ax)))
% do nothing
        else
            if strcmp(get(handles.warningbox, 'Checked'),'on')
                warndlg('Some values of the semimajor axis are negative or null. It may be that the point is escaping to infinity or is falling into the singularity, so that the semimajor axis is ill defined.')
            end
        end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        data_sep = num2str(2*pi*100000*OutStep);
        flag_FMFT = num2str(1);
        d = size(q_vec(:,1),1);    
        ndata = num2str(2^(floor(log2(d))));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        qp2SD
        Sprime_vec = S_vec*RotS;
        Dprime_vec = D_vec*RotD;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        qp2uv  
%%%%%%%%%%%%%%%%%%%%%  
        SoDo2uRvR
%%%%%%%%%%%%%%%%%%%%%
        DelaunayprimeforFMFT
        WriteInputLGG3
%%%%%%%%%%%%%%%%%%%%%
        cd([KeplerDir, '/FMFT'])

        min_f = str2num(get(handles.editGG3_min_Freq1,'String'));
        max_f = str2num(get(handles.editGG3_max_Freq1,'String'));
        if (sign(min_f) ~= sign(max_f) | min_f == 0 | max_f == 0)
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');
            nfreq = num2str(2);
            cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                data_sep,' ',ndata,' ',['<inputAct1_',extstr,'.txt'],' ',['>FMFT_of_Act1_',extstr,'.txt']];  
            eval(cmd_string)
            [frq_1] = textread(['FMFT_of_Act1_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
            if numel(frq_1)== 0
                freq_1(int) = NaN;
                freq_min_1(int) = NaN;
                freq_max_1(int) = NaN;
                freq_2(int) = NaN;
                freq_min_2(int) = NaN;
                freq_max_2(int) = NaN;        
                freq_3(int) = NaN;
                freq_min_3(int) = NaN;
                freq_max_3(int) = NaN;
                cd(KeplerDir)
                continue
            end
            if abs(frq_1(1)) > 1
                freq_1(int) = frq_1(1);
            else
                freq_1(int) = frq_1(2);
            end
        else
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');         
            nfreq = num2str(1);
            cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                data_sep,' ',ndata,' ',['<inputAct1_',extstr,'.txt'],' ',['>FMFT_of_Act1_',extstr,'.txt']];  
            eval(cmd_string)
            [frq_1] = textread(['FMFT_of_Act1_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
            if numel(frq_1)== 0
                freq_1(int) = NaN;
                freq_min_1(int) = NaN;
                freq_max_1(int) = NaN;
                freq_2(int) = NaN;
                freq_min_2(int) = NaN;
                freq_max_2(int) = NaN;        
                freq_3(int) = NaN;
                freq_min_3(int) = NaN;
                freq_max_3(int) = NaN;
                cd(KeplerDir)
                continue
            end
            freq_1(int) = frq_1;
        end

        min_f = str2num(get(handles.editGG3_min_Freq2,'String'));
        max_f = str2num(get(handles.editGG3_max_Freq2,'String'));
        if (sign(min_f) ~= sign(max_f) | min_f == 0 | max_f == 0)
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');
            nfreq = num2str(2);
            cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                data_sep,' ',ndata,' ',['<inputAct2_',extstr,'.txt'],' ',['>FMFT_of_Act2_',extstr,'.txt']];  
            eval(cmd_string)
            [frq_2] = textread(['FMFT_of_Act2_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
            if numel(frq_2)== 0
                freq_1(int) = NaN;
                freq_min_1(int) = NaN;
                freq_max_1(int) = NaN;
                freq_2(int) = NaN;
                freq_min_2(int) = NaN;
                freq_max_2(int) = NaN;        
                freq_3(int) = NaN;
                freq_min_3(int) = NaN;
                freq_max_3(int) = NaN;
                cd(KeplerDir)
                continue
            end            
            if abs(frq_2(1)) > 1
                freq_2(int) = frq_2(1);
            else
                freq_2(int) = frq_2(2);
            end
        else
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');         
            nfreq = num2str(1);
            cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                data_sep,' ',ndata,' ',['<inputAct2_',extstr,'.txt'],' ',['>FMFT_of_Act2_',extstr,'.txt']];  
            eval(cmd_string)
            [frq_2] = textread(['FMFT_of_Act2_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
            if numel(frq_2)== 0
                freq_1(int) = NaN;
                freq_min_1(int) = NaN;
                freq_max_1(int) = NaN;
                freq_2(int) = NaN;
                freq_min_2(int) = NaN;
                freq_max_2(int) = NaN;        
                freq_3(int) = NaN;
                freq_min_3(int) = NaN;
                freq_max_3(int) = NaN;
                cd(KeplerDir)
                continue
            end            
            freq_2(int) = frq_2;
        end

        min_f = str2num(get(handles.editGG3_min_Freq3,'String'));
        max_f = str2num(get(handles.editGG3_max_Freq3,'String'));
        if (sign(min_f) ~= sign(max_f) | min_f == 0 | max_f == 0)
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');
            nfreq = num2str(2);
            cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                data_sep,' ',ndata,' ',['<inputAct3_',extstr,'.txt'],' ',['>FMFT_of_Act3_',extstr,'.txt']];  
            eval(cmd_string)
            [frq_3] = textread(['FMFT_of_Act3_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
            if numel(frq_3)== 0
                freq_1(int) = NaN;
                freq_min_1(int) = NaN;
                freq_max_1(int) = NaN;
                freq_2(int) = NaN;
                freq_min_2(int) = NaN;
                freq_max_2(int) = NaN;        
                freq_3(int) = NaN;
                freq_min_3(int) = NaN;
                freq_max_3(int) = NaN;
                cd(KeplerDir)
                continue
            end       
            if abs(frq_3(1)) > 1
                freq_3(int) = frq_3(1);
            else
                freq_3(int) = frq_3(2);
            end
        else
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');         
            nfreq = num2str(1);
            cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                data_sep,' ',ndata,' ',['<inputAct3_',extstr,'.txt'],' ',['>FMFT_of_Act3_',extstr,'.txt']];  
            eval(cmd_string)
            [frq_3] = textread(['FMFT_of_Act3_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);      
            if numel(frq_3)== 0
                freq_1(int) = NaN;
                freq_min_1(int) = NaN;
                freq_max_1(int) = NaN;
                freq_2(int) = NaN;
                freq_min_2(int) = NaN;
                freq_max_2(int) = NaN;        
                freq_3(int) = NaN;
                freq_min_3(int) = NaN;
                freq_max_3(int) = NaN;
                cd(KeplerDir)
                continue
            end        
            freq_3(int) = frq_3;              
        end
        %-------------- Frequency Modulation Indicator (FMI)---------------
        str_FMFT_pick = num2str(FMFT_pick);
        %----------------------- Freq1 ------------------------------------
        n_step = str2num(get(handles.nstep1LGG3,'String'));
        if n_step >= 1
            min_f = str2num(get(handles.editGG3_min_Freq1,'String'));
            max_f = str2num(get(handles.editGG3_max_Freq1,'String'));
            if (sign(min_f) ~= sign(max_f) | min_f == 0 | max_f == 0)
                min_f = num2str(1000*min_f,'%6.12f');
                max_f = num2str(1000*max_f,'%6.12f');
                nfreq = num2str(2);
                for rr = 1:n_step + 1
                    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                        data_sep,' ',str_FMFT_pick,' ','<inputAct1_',num2str(rr),'_',extstr,'.txt',' ','>FMFT_of_Act1_',num2str(rr),'_',extstr,'.txt'];
                    eval(cmd_string)
                    try
                        [frq] = textread(['FMFT_of_Act1_',num2str(rr),'_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
                    catch
                        warndlg('Some error occurred: the corresponding FMI 1 value will be left blank.')
                        freq = NaN*ones(1,n_step + 1);
                        break
                    end
                    if numel(frq) < 2
                        warndlg('Some error occurred: the corresponding FMI 1 value will be left blank.')
                        freq = NaN*ones(1,n_step + 1);
                        break
                    end                        
                    if abs(frq(1)) > 1
                        freq(rr) = frq(1);
                    else
                        freq(rr) = frq(2);
                    end
                end
            else
                min_f = num2str(1000*min_f,'%6.12f');
                max_f = num2str(1000*max_f,'%6.12f');
                nfreq = num2str(1);
                for rr = 1:n_step + 1
                    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                        data_sep,' ',str_FMFT_pick,' ','<inputAct1_',num2str(rr),'_',extstr,'.txt',' ','>FMFT_of_Act1_',num2str(rr),'_',extstr,'.txt'];
                    eval(cmd_string)
                    try
                        frq = textread(['FMFT_of_Act1_',num2str(rr),'_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
                    catch
                        warndlg('Some error occurred: the corresponding FMI 1 value will be left blank.')
                        freq = NaN*ones(1,n_step + 1);
                        break
                    end
                    if numel(frq) == 0
                        warndlg('Some error occurred: the corresponding FMI 1 value will be left blank.')
                        freq = NaN*ones(1,n_step + 1);
                        break
                    end                    
                    freq(rr) = frq;
                end
            end

            freq_min_1(int) = min(freq);
            freq_max_1(int) = max(freq);

            %           Set min FMI1 = -12
            if abs((freq_max_1(int)-freq_min_1(int))/(freq_max_1(int)+freq_min_1(int))) < 1e-12
                freq_min_1(int) = 1;
                freq_max_1(int) = (1+1e-12)/(1-1e-12);
            end
        end
%--------------------- Freq2 -- -------------------------------
        n_step = str2num(get(handles.nstep2LGG3,'String'));
        if n_step >= 1
            min_f = str2num(get(handles.editGG3_min_Freq2,'String'));
            max_f = str2num(get(handles.editGG3_max_Freq2,'String'));        
            if (sign(min_f) ~= sign(max_f) | min_f == 0 | max_f == 0)
                min_f = num2str(1000*min_f,'%6.12f');
                max_f = num2str(1000*max_f,'%6.12f');
                nfreq = num2str(2);
                for rr = 1:n_step + 1
                    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                        data_sep,' ',str_FMFT_pick,' ','<inputAct2_',num2str(rr),'_',extstr,'.txt',' ','>FMFT_of_Act2_',num2str(rr),'_',extstr,'.txt'];  
                    eval(cmd_string)
                    try
                        [frq] = textread(['FMFT_of_Act2_',num2str(rr),'_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
                    catch
                        warndlg('Some error occurred: the corresponding FMI 2 value will be left blank.')
                        freq = NaN*ones(1,n_step + 1);
                        break
                    end
                     if numel(frq) < 2
                        warndlg('Some error occurred: the corresponding FMI 2 value will be left blank.')
                        freq = NaN*ones(1,n_step + 1);
                        break
                    end                                       
                    if abs(frq(1)) > 1
                        freq(rr) = frq(1);
                    else
                        freq(rr) = frq(2);
                    end
                end
            else
                min_f = num2str(1000*min_f,'%6.12f');
                max_f = num2str(1000*max_f,'%6.12f');         
                nfreq = num2str(1);
                for rr = 1:n_step + 1
                    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                        data_sep,' ',str_FMFT_pick,' ','<inputAct2_',num2str(rr),'_',extstr,'.txt',' ','>FMFT_of_Act2_',num2str(rr),'_',extstr,'.txt'];  
                    eval(cmd_string) 
                    try
                        frq = textread(['FMFT_of_Act2_',num2str(rr),'_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
                    catch
                        warndlg('Some error occurred: the corresponding FMI 2 value will be left blank.')
                        freq = NaN*ones(1,n_step + 1);
                        break
                    end
                    if numel(frq) == 0
                        warndlg('Some error occurred: the corresponding FMI 2 value will be left blank.')
                        freq = NaN*ones(1,n_step + 1);
                        break
                    end                       
                    freq(rr) = frq;
                end
            end

            freq_min_2(int) = min(freq);
            freq_max_2(int) = max(freq);

%           Set min FMI2 = -12        
            if abs((freq_max_2(int)-freq_min_2(int))/(freq_max_2(int)+freq_min_2(int))) < 1e-12
                freq_min_2(int) = 1;
                freq_max_2(int) = (1+1e-12)/(1-1e-12);
            end          
        end
%--------------------- Freq3 ----------------------------------
        n_step = str2num(get(handles.nstep3LGG3,'String'));
        if n_step >= 1
            min_f = str2num(get(handles.editGG3_min_Freq3,'String'));
            max_f = str2num(get(handles.editGG3_max_Freq3,'String'));        
            if (sign(min_f) ~= sign(max_f) | min_f == 0 | max_f == 0)
                min_f = num2str(1000*min_f,'%6.12f');
                max_f = num2str(1000*max_f,'%6.12f');
                nfreq = num2str(2);              
                for rr = 1:n_step + 1
                    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                        data_sep,' ',str_FMFT_pick,' ','<inputAct3_',num2str(rr),'_',extstr,'.txt',' ','>FMFT_of_Act3_',num2str(rr),'_',extstr,'.txt'];  
                    eval(cmd_string)
                    try
                        [frq] = textread(['FMFT_of_Act3_',num2str(rr),'_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
                    catch
                        warndlg('Some error occurred: the corresponding FMI 3 value will be left blank.')
                        freq = NaN*ones(1,n_step + 1);
                        break
                    end
                    
                    if numel(frq) < 2
                        warndlg('Some error occurred: the corresponding FMI 3 value will be left blank.')
                        freq = NaN*ones(1,n_step + 1);
                        break
                    end                       
                    
                    if abs(frq(1)) > 1
                        freq(rr) = frq(1);
                    else
                        freq(rr) = frq(2);
                    end
                end
            else
                min_f = num2str(1000*min_f,'%6.12f');
                max_f = num2str(1000*max_f,'%6.12f');         
                nfreq = num2str(1);
                for rr = 1:n_step + 1
                    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                        data_sep,' ',str_FMFT_pick,' ','<inputAct3_',num2str(rr),'_',extstr,'.txt',' ','>FMFT_of_Act3_',num2str(rr),'_',extstr,'.txt'];  
                    eval(cmd_string) 
                    try
                        frq = textread(['FMFT_of_Act3_',num2str(rr),'_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
                    catch
                        warndlg('Some error occurred: the corresponding FMI 3 value will be left blank.')
                        freq = NaN*ones(1,n_step + 1);
                        break
                    end   
                    if numel(frq) == 0
                        warndlg('Some error occurred: the corresponding FMI 3 value will be left blank.')
                        freq = NaN*ones(1,n_step + 1);
                        break
                    end   
                    freq(rr) = frq;
                end
            end

            freq_min_3(int) = min(freq);
            freq_max_3(int) = max(freq);

%           Set min FMI3 = -12        
            if abs((freq_max_3(int)-freq_min_3(int))/(freq_max_3(int)+freq_min_3(int))) < 1e-12
                freq_min_3(int) = 1;
                freq_max_3(int) = (1+1e-12)/(1-1e-12);
            end
        end
%--------------------- End FMI --------------------------------------------
        cd(KeplerDir)
        clear DiffEquation
    end
%---------------------------------------
    ccount = ccount + 1;
    perc = ccount/int_tot*100;
    fprintf('\n\n')
    if ccount == 1
        lgt = fprintf('\b\b%4.2f%%',perc);
    else
        fprintf(repmat('\b', 1, lgt));
        lgt = fprintf('%4.2f%%',perc) + 2;
    end
%---------------------------------------
end

n_step = str2num(get(handles.nstep1LGG3,'String'));
if n_step >= 1
    FMI_1 = log10(abs((freq_max_1 - freq_min_1)./(freq_max_1 + freq_min_1)));
else
    FMI_1 = NaN*ones(1, int_tot);
end

n_step = str2num(get(handles.nstep2LGG3,'String'));
if n_step >= 1    
    FMI_2 = log10(abs((freq_max_2 - freq_min_2)./(freq_max_2 + freq_min_2)));
else
    FMI_2 = NaN*ones(1, int_tot);
end

n_step = str2num(get(handles.nstep3LGG3,'String'));
if n_step >= 1     
    FMI_3 = log10(abs((freq_max_3 - freq_min_3)./(freq_max_3 + freq_min_3)));
else
    FMI_3 = NaN*ones(1, int_tot);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
compted = str2num(get(handles.count,'String'));
compted = compted + 1;
set(handles.count,'String', num2str(compted));

list = strread(cd, '%s','delimiter',strrep(filesep,'\','\\'));
dim = size(list);
curdir = list{dim(1,1), dim(1,2)};

partial = str2num(get(handles.count,'String'));
total = max(row_tot, col_tot);
perc = partial/total;
completed = perc*100;

display('------------------------------------------------------------')
if row_tot <= col_tot
    display(['Column ',extstr,': computation completed at ', datestr(now)])
    display([curdir, ' -- Total column computed: ', get(handles.count,'String'),...
        ', equivalent to ',num2str(completed,'%4.2f'),'% of the total'])
else
    display(['Row ',extstr,': computation completed at ', datestr(now)])
    display([curdir, ' -- Total row computed: ', get(handles.count,'String'),...
        ', equivalent to ',num2str(completed,'%4.2f'),'% of the total']) 
end

%%%%%%%%%%%%%%%% Total progress %%%%%%%%%%%%%%%%%%%%%%%%%%
cd ..
failure = true;
while failure
    try
        fid = fopen('WaitBar.txt','a');
        fwrite(fid,'1');
        fclose(fid);
        failure = false;
    end
end
failure = true;
while failure
    try
        fid = fopen('WaitBar.txt','r');
        A = fread(fid,'*char');
        num = str2num(A);
        failure = false;
    end
end
perc = num2str(sum(num)/ext_tot*100,'%4.2f');
%--------------------------------------------------------------------------
%if strcmp(get(handles.waitbars, 'Checked'),'on')
    cd(KeplerDir)
    list = strread(cd, '%s','delimiter',strrep(filesep,'\','\\'));
    dim = size(list);
    curdir = list{dim(1,1), dim(1,2)};
    update = [curdir,' - Total progress: ', perc, '%.',' Starting time: ', begin];
    
    try
        waitbar(sum(num)/ext_tot, mainbar, update);
    catch ME
        % do nothing
    end
%else
    % do nothing
%end
%--------------------------------------------------------------------------
cd(KeplerDir)
disp(['|============= Total progress: ',perc,'% ===============|']);
disp('    ')
%%%%%%%%%%%%%%%%%%%%%% End Total progress %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Y = [freq_1; freq_2; freq_3; FMI_1; FMI_2; FMI_3];
delete FMFT/*.txt
